Attribute VB_Name = "Module1"
Option Explicit

' Funciones api para el Hook
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" ( _
    ByVal hwnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" ( _
    ByVal lpPrevWndFunc As Long, _
    ByVal hwnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" ( _
    ByVal hwnd As Long, _
    ByVal Msg As Long, _
    wParam As Any, lParam As Any) As Long

' para usar con el picturebox
''''''''''''''''''''''''''''''''''''''
Public Declare Function GetSystemMetrics Lib "user32" ( _
    ByVal nIndex As Long) As Long

Public Const SM_CYHSCROLL = 3
Public Const SM_CXVSCROLL = 2


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Constantes y variables
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Const GWL_WNDPROC = (-4)
Private Const WM_MOUSEWHEEL = &H20A
Private Const WM_VSCROLL As Integer = &H115

Dim PrevProc As Long

' instala el hook
Public Sub Hook(Obj As Object)
    PrevProc = SetWindowLong(Obj.hwnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub
' quita el hook
Public Sub UnHook(Obj As Object)
    SetWindowLong Obj.hwnd, GWL_WNDPROC, PrevProc
End Sub

' Procedimiento de ventana que chequea si se est usndo la rueda del scroll
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function WindowProc(ByVal hwnd As Long, _
                           ByVal uMsg As Long, _
                           ByVal wParam As Long, _
                           ByVal lParam As Long) As Long

    WindowProc = CallWindowProc(PrevProc, hwnd, uMsg, wParam, lParam)
    
    If uMsg = WM_MOUSEWHEEL Then
        If wParam < 0 Then
            'Scroll hacia abajo
            SendMessage hwnd, WM_VSCROLL, ByVal 1, ByVal hwnd
        Else
            ' scroll hacia arriba
            SendMessage hwnd, WM_VSCROLL, ByVal 0, ByVal hwnd
        End If
    End If
End Function
